#include <stdio.h>
#include <errno.h>
#include <getargs.h>

#define E(x) fprintf(stderr,"%s\n", x);

int	Echo = 0;

ARG Argtab[] =
{
	{ 'e', BOOLEAN, &Echo, "Echo directory names as they're removed" }
};

#define	ASIZE ( sizeof(Argtab)/sizeof(ARG) )

/*----------------------------------------------------------------------*/

usage()
{
	E("\nUsage: rmdir [-e] name [... name]\n" );

	E("Delete a directory or group of directories having the indicated")
	E("name or names. Directories must be empty (see rm).");

	E("\nRmdir: Copyright (C) 1986, Allen I. Holub. All rights reserved."); 

	exit( 1 );
}

/*----------------------------------------------------------------------*/

main(argc, argv)
char	**argv;
{
	register int	exit_val = 0;

	argc = getargs(argc, argv, Argtab, ASIZE, usage);

	for( ++argv; --argc > 0 ; ++argv )
	{
		if( Echo )
			fprintf(stderr, "Removing %s", *argv );

		if( !isdir(*argv) )
		{
			if( !Echo )
				printf("%s", *argv );

			printf(": may not rmdir a file, use rm\n");
		}
		else if( rmdir(*argv) < 0 )
		{
			perror( Echo ? " " : *argv );
			exit_val = 1;
		}
		else if( Echo )
			printf("\n");
	}

	exit( exit_val );
}
