#include <stdio.h>
#include <process.h>
#include <dos.h>

extern char	*getenv();

#ifndef DEBUG
#   define avail_mem()
#else

    avail_mem()
    {
	unsigned long	total;
	union	 REGS	regs;
	struct	 SREGS	segregs;

	int86( 0x12, &regs, &regs );
	segread( &segregs );

	total = (unsigned long)regs.x.ax * 1024;

	printf("%lu bytes out of %lu available for child process\n",
		total - (((unsigned long)segregs.cs - 16) * 16)  ,
		total );
    }

#endif

/*------------------------------------------------------------*/

err( str )
char	*str;
{
	while( *str )
		putch( *str++ );

	putch('\r');
	putch('\n');
	exit( 1 );
}

/*------------------------------------------------------------*/

main( argc, argv )
char	**argv;
{
	/* This program executes it's command line and then
	 * returns to the shell. It uses the COMSPEC environment
	 * to determine which shell to invoke.
	 */

	extern  int _amblksiz;	/* Microsoft compiler */

	char   *comspec;
	char   *p;
	static char  cmdline[128];
	static char  *myargv[11] ;
	int    i;

	_amblksiz = 512;

	avail_mem();

	if( argc < 2  ||  argv[1][0] == '-' )
	    err("usage: run <program>\n" );

	if( !(comspec = getenv("COMSPEC")) )
	    err( "run: COMSPEC environment must be defined\n" );

	if( (p = getenv("SHLEV"))  &&  atoi(p) )
	    err( "run: must execute run from login shell\n" );

	--argc;
	memcpy ( myargv, ++argv, 10 * sizeof(char**) );
	spawnvp( P_WAIT, *argv,  myargv );

	for( i = 6; i <=20; i++ )
		close( i );

	execl  ( comspec, comspec, "-l", NULL );
}
